;***************************************************************
;*
;*  DELETE ALL FILES AND DIRECTORIS IN DESTINATION DISK DRIVE
;*
;	<INPUT>  : AL  = DRIVE NO
;
;
GET_CD_BUF		DB  64 DUP(0) 	; CURRENT DIRECTORY TEXT
;
DEL_FIND_BUF_RES	DB  21 DUP(?)	; RESERVED
DEL_FIND_BUF_ATTR	DB	0	; ATTRIBUTE FOUND
DEL_FIND_BUF_TIME	DW	0	; TIME
DEL_FIND_BUF_DATE	DW	0	; DATE
DEL_FIND_BUF_SIZE_L	DW	0	; LOW(SIZE)
DEL_FIND_BUF_SIZE_H	DW	0	; HIGH(SIZE)
DEL_FIND_BUF_PNAME	DB  13 DUP(?)	; PACKED NAME
;
DELETE_PATH		DB  '@:',128 DUP (0)
DEL_WILD_FILE		DB  '@:*.*',0
;
;
FILE_DELETE:
	PUSH	AX 	 		;
	PUSH	CX 			;
	PUSH	DX			;
	PUSH	SI			;
	PUSH	DI			;
;
	ADD	AL,'A'			;
	MOV	DELETE_PATH,AL		; SET DESTINATION DRIVE NO
	MOV	DEL_WILD_FILE,AL	;
;
	MOV	DX,OFFSET DELETE_PATH	; CHANGE DIRECTORY TO ROOT
	MOV	SI,DX			;
	MOV	BYTE PTR[SI+2],"\"	;
	MOV	BYTE PTR[SI+3],0	;
	MOV	AH,CH_DIR		; CHANGE DIRECTORY FUNC
	INT	BDOS			;
;
DELETE_FILE:
	MOV	AH,SET_DTA		; 
	MOV	DX,OFFSET DEL_FIND_BUF_RES
	INT	BDOS			; SET DTA
;
	MOV	CX,0007H		; ATTRIBUTES S,H,AND R
	MOV	AH,SEARCH_FIRST		;
	MOV	DX,OFFSET DEL_WILD_FILE
	INT	BDOS			; SEARCH FIRST DERECTORY ENTRY
	JC	NEXT_PATH		; NO FILES IN THE CURRENT DIRECTORY
;
FILE_DEL_10:
	MOV	SI,OFFSET DEL_FIND_BUF_PNAME
	MOV	DI,OFFSET DELETE_PATH+2
	MOV	CX,13			;
	REP	MOVSB			;
	MOV	BYTE PTR [DI],0		; ASCIZ 0
;
	MOV	AH,CH_MODE		;
	MOV	DX,OFFSET DELETE_PATH
	MOV	CX,0020H		; ATTRIBUTE A
	MOV	AL,01H			; SET MODE FUNC.
	INT	BDOS			;
;
	MOV	AH,DEL_FILE		; DELETE FILE ENTRY
	MOV	DX,OFFSET DELETE_PATH
	INT	BDOS			;
	JNC	FILE_DEL_15		; OK
	JMP	FILE_DEL_ERROR		; ERROR EXIT
FILE_DEL_15:
;
	MOV	AH,SEARCH_NEXT		;
	INT	BDOS			;
;
	JNC	FILE_DEL_10		; JUMP TO NEXT FILE DELETE
;
NEXT_PATH:
	MOV	CX,0010H		; SUB DIRECTORY ATTRIBUTE
	MOV	AH,SEARCH_FIRST		;
	MOV	DX,OFFSET DEL_WILD_FILE
	INT	BDOS			; SEARCH FIRST DERECTORY ENTRY
;
	JC	ROOT_CHECK		; NO DIRECTORY ENTRY IN CURRENT DIR.
	MOV	SI,OFFSET DEL_FIND_BUF_PNAME
	CMP	BYTE PTR [SI],2EH	; ..DIR ENTRY IN SUB DIR.
	JNZ	FILE_DEL_30
;
	MOV	AH,SEARCH_NEXT 		;
	INT	BDOS			; SEARCH NEXT DERECTORY ENTRY
;
	JC	FILE_DEL_ERROR		; NO DIRECTORY ENTRY IN CURRENT DIR.
;
	MOV	SI,OFFSET DEL_FIND_BUF_PNAME
	CMP	BYTE PTR [SI],2EH	; ..DIR ENTRY
	JNZ	FILE_DEL_30
	MOV	AH,SEARCH_NEXT	 	;
	INT	BDOS			; SEARCH NEXT DERECTORY ENTRY
;
	JC	ROOT_CHECK		; NOT . OR .. DIR ENTRY
;
FILE_DEL_30:
	MOV	DI,OFFSET DELETE_PATH+2
	MOV	CX,13			;
	REP	MOVSB			;
	MOV	BYTE PTR [DI],0		; ASCIZ 0
;
	MOV	AH,CH_DIR	 	; CHANGE DIRECTORY TO SUB DIR
	MOV	DX,OFFSET DELETE_PATH
	INT	BDOS			;
	JMP	DELETE_FILE		; DELETE FILES IN THE NEXT PATH
;
ROOT_CHECK:
	MOV	DL,DEST			;
	INC	DL			; DESTINATION DRIVE NUMBER
	MOV	SI,OFFSET GET_CD_BUF
	MOV	AH,GET_CUR		; GET CURRENT DIRECTORY TEXT
	INT	BDOS			;
;
	CMP	BYTE PTR[SI],0		; IF [SI]=0,CURRENT DIR = ROOT
	JZ	FILE_DEL_NORMAL_END	; NO FILE AND DIRECTORY IN DISKETTE
;
	MOV	DI,OFFSET DELETE_PATH+2
	MOV	WORD PTR [DI],".."	; RELATIVE DIRETORY ..
	MOV	BYTE PTR [DI+2],0	; ASCIZ 0
	MOV	DX,OFFSET DELETE_PATH
	MOV	AH,CH_DIR		; CHANGE CURRENT DIR TO PARENT
	INT	BDOS			;
;
	MOV	SI,OFFSET GET_CD_BUF	; BEFORE PATH TEXT
	MOV	DI,OFFSET DELETE_PATH+2
	MOV	BYTE PTR [DI],"\"	; ROOT PATH 
	INC	DI
	MOV	CX,64			; MAX CURRENT DIRECTORY TEXT LENGTH
	REP	MOVSB			;
	MOV	BYTE PTR [DI],0		; ASCIZ 0
;
	MOV	DX,OFFSET DELETE_PATH
	MOV	AH,RM_DIR		; REMOVE DIRECTORY FUNC.
	INT	BDOS
	JC	FILE_DEL_ERROR		; ERROR EXIT
	JMP	NEXT_PATH		;
;
FILE_DEL_ERROR:				; ERROR RETURN
	STC				;
	JMP	SHORT FILE_DEL_END	;
FILE_DEL_NORMAL_END:
	CLC				; NORMAL RETURN
;
FILE_DEL_END:
	POP	DI			;
	POP	SI			;
	POP	DX			;
	POP	CX			;
	POP	AX			;
	RET				;
